function [output] = ge_grid( x_max, x_min, y_max, y_min, varargin )
%% ge_grid( x_min, x_max, y_min, y_max, varargin)
%     y_(min/max) & x_(min/max)are decimal degree coordinates (WGS84)
% AuthorizedOptions = {'id',...
%                      'idTag', ...
%                      'name',...
%                      'timeStamp', ...
%                      'timeSpanStart', ...
%                      'timeSpanStop', ...
%                      'description', ...
%                      'visibility', ...
%                      'LineWidth', ...
%                      'LineColor', ...
%                      'PolyColor', ...
%                      'altitude', ...
%                      'altitudeMode', ...
%                      'latRes', ...
%                      'lonRes', ...
%                      'extrude', ...
%                      'Snippet'};
                 
AuthorizedOptions = {'id',...
                     'idTag', ...
                     'name',...
                     'timeStamp', ...
                     'timeSpanStart', ...
                     'timeSpanStop', ...
                     'description', ...
                     'visibility', ...
                     'LineWidth', ...
                     'LineColor', ...
                     'PolyColor', ...
                     'altitude', ...
                     'altitudeMode', ...
                     'latRes', ...
                     'lonRes', ...
                     'extrude', ...
                     'Snippet'};

for k = 1:2:length(varargin(:))
    if ~strcmp(varargin{k}, AuthorizedOptions)
        error(['Unauthorized parameter name ' 39 varargin{k} 39 ' in ' 10,...
            'parameter/value passed to ' 39 mfilename 39 '.']);
    end
end
                     
                            
if( isempty( y_min ) || isempty( y_max ) || isempty( x_min ) || isempty( x_max) )
    error('empty coordinates passed to ge_grid(...).');
end

         %id = 'default_grid';
      idTag = 'id';
       %name = 'ge_grid';
%description = '';
 visibility = 1;
  LineColor = '00000000';
  PolyColor = 'ffffffff';
  LineWidth = 0.0;
    timeStamp = ' ';
timeSpanStart = ' ';
 timeSpanStop = ' ';
    %Snippet = '';
   altitude = 1.0;
   extrude = 1;
 altitudeMode = 'relativeToGround';
    latRes = abs( y_max - y_min );
    lonRes = abs( x_min - x_max );
    tessellate = 0;


v = ge_parse_pairs(varargin);

for j = 1:length(v)
    eval(v{j});
end

output= '';

col = y_min;
for row = (x_min):lonRes:(x_max-lonRes)
    output = [output, ge_box(  row+lonRes, row, y_max, y_min, 'timeStamp', timeStamp, 'timeSpanStart', timeSpanStart, 'timeSpanStop', timeSpanStop, 'altitude', altitude, 'tessellate', tessellate, 'altitudeMode', altitudeMode, 'extrude', extrude, 'id', ['gridcell_',int2str(row),'_',int2str(col)], 'idTag', idTag, 'name', ['gridcell_',int2str(row),'_',int2str(col)], 'LineWidth', LineWidth, 'LineColor', LineColor, 'PolyColor', PolyColor , 'visibility', visibility) ];
end  
row = x_min;
for col = (y_min):latRes:(y_max-latRes)
    output = [output, ge_box( x_min, x_max, col+latRes, col, 'timeStamp', timeStamp, 'timeSpanStart', timeSpanStart, 'timeSpanStop', timeSpanStop, 'altitude', altitude, 'tessellate', tessellate, 'altitudeMode', altitudeMode, 'extrude', extrude, 'id', ['gridcell_',int2str(row),'_',int2str(col)], 'idTag', idTag, 'name', ['gridcell_',int2str(row),'_',int2str(col)], 'LineWidth', LineWidth, 'LineColor', LineColor, 'PolyColor', PolyColor , 'visibility', visibility) ];
end
 
