function varargout = wells_coppersmith_window(varargin)
% WELLS_COPPERSMITH_WINDOW M-file for wells_coppersmith_window.fig
%      WELLS_COPPERSMITH_WINDOW, by itself, creates a new WELLS_COPPERSMITH_WINDOW or raises the existing
%      singleton*.
%
%      H = WELLS_COPPERSMITH_WINDOW returns the handle to a new WELLS_COPPERSMITH_WINDOW or the handle to
%      the existing singleton*.
%
%      WELLS_COPPERSMITH_WINDOW('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in WELLS_COPPERSMITH_WINDOW.M with the given input arguments.
%
%      WELLS_COPPERSMITH_WINDOW('Property','Value',...) creates a new WELLS_COPPERSMITH_WINDOW or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before wells_coppersmith_window_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to wells_coppersmith_window_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help wells_coppersmith_window

% Last Modified by GUIDE v2.5 25-Sep-2006 14:11:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @wells_coppersmith_window_OpeningFcn, ...
                   'gui_OutputFcn',  @wells_coppersmith_window_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before wells_coppersmith_window is made visible.
function wells_coppersmith_window_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to wells_coppersmith_window (see VARARGIN)

% Choose default command line output for wells_coppersmith_window
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes wells_coppersmith_window wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = wells_coppersmith_window_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


%-------------------------------------------------------------------------
%     Fault sense (popupmenu)
%-------------------------------------------------------------------------
function popupmenu_fault_sense_Callback(hObject, eventdata, handles)
global IFAULT_SENSE
IFAULT_SENSE = single(get(hObject,'Value'));

% --- Executes during object creation, after setting all properties.
function popupmenu_fault_sense_CreateFcn(hObject, eventdata, handles)
global IFAULT_SENSE
IFAULT_SENSE = 1.0;
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%-------------------------------------------------------------------------
%     Mw (textfield)
%-------------------------------------------------------------------------
function edit_wc_mc_Callback(hObject, eventdata, handles)
x = str2num(get(hObject,'String'));
set(hObject,'String',num2str(x,'%4.2f'));
set(findobj('Tag','edit_eq_mo'),'String',num2str(x,'%4.2f'));

% --- Executes during object creation, after setting all properties.
function edit_wc_mc_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
x = str2num(get(findobj('Tag','edit_eq_mo'),'String'));
set(hObject,'String',num2str(x,'%4.2f'));

%-------------------------------------------------------------------------
%     Calculation button (pushbutton)
%-------------------------------------------------------------------------
function pushbutton_wc_calc_Callback(hObject, eventdata, handles)
global IFAULT_SENSE
mw = str2num(get(findobj('Tag','edit_wc_mc'),'String'));
% ifault = get(findobj('Tag','popumenu_fault_sense'),'Value')
ifault = IFAULT_SENSE; % remove global IFAULT_SENSE for near future
if ifault == 1
    al = 4.38; bl = 1.49; aw = 4.06; bw = 2.25;   
elseif ifault == 2  % strike-slip
    al = 4.33; bl = 1.49; aw = 3.80; bw = 2.59;   
elseif ifault == 3  % reverse
    al = 4.49; bl = 1.49; aw = 4.37; bw = 1.95;     
else                % normal
    al = 4.34; bl = 1.54; aw = 4.04; bw = 2.11;    
end
    fault_l = wells_coppersmith(al,bl,mw);
    fault_w = wells_coppersmith(aw,bw,mw); 
    set(findobj('Tag','edit_wc_length'),'String',num2str(fault_l,'%6.2f'));
	set(findobj('Tag','edit_wc_width'),'String',num2str(fault_w,'%5.2f'));

%-------------------------------------------------------------------------
%     Calculated fault length (textfield)
%-------------------------------------------------------------------------
function edit_wc_length_Callback(hObject, eventdata, handles)
x = single(get(hObject,'Value'));
% 1: strike-slip
% 2: reverse
% 3: normal

% --- Executes during object creation, after setting all properties.
function edit_wc_length_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_wc_length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%-------------------------------------------------------------------------
%     Calculated fault width (textfield)
%-------------------------------------------------------------------------
function edit_wc_width_Callback(hObject, eventdata, handles)
% hObject    handle to edit_wc_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_wc_width as text
%        str2double(get(hObject,'String')) returns contents of edit_wc_width as a double


% --- Executes during object creation, after setting all properties.
function edit_wc_width_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_wc_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%-------------------------------------------------------------------------
%     Reflect results button (pushbutton)
%-------------------------------------------------------------------------
function pushbutton_reflect_Callback(hObject, eventdata, handles)
x = str2num(get(findobj('Tag','edit_wc_length'),'String'));
y = str2num(get(findobj('Tag','edit_wc_width'),'String'));
if isempty(x)~=1 && isempty(y)~=1
set(findobj('Tag','edit_eq_length'),'String',num2str(x,'%6.2f'));
set(findobj('Tag','edit_eq_width'),'String',num2str(y,'%6.2f'));
end

%-------------------------------------------------------------------------
%     close button (pushbutton)
%-------------------------------------------------------------------------
function pushbutton_wc_close_Callback(hObject, eventdata, handles)
    delete(figure(gcf));
    
%-------------------------------------------------------------------------
%     WC equation
%-------------------------------------------------------------------------   
function wcout = wells_coppersmith(a,b,m)
x = (m - a) / b;
wcout = 10.0.^x;


        

